/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package action;

import model.Korisnik;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.transaction.UserTransaction;
import repozitorijum.Repozitorijum;
import webconstants.WebConstants;

/**
 *
 * @author student
 */
public class LoginAction extends AbstractAction {

    @Override
    public String execute(HttpServletRequest request) throws Exception {
        String korisnickoIme = request.getParameter("inputKorisnickoIme");
        String korisnickaSifra = request.getParameter("inputKorisnickaSifra");
        try {
            Korisnik korisnik = login(korisnickoIme, korisnickaSifra);
            HttpSession session = request.getSession(true);
            session.setAttribute(WebConstants.LOGIN_KORISNIK, korisnik);
            return WebConstants.PAGE_POCETNA;
        } catch (Exception ex) {
            throw ex;
        }

    }

    private Korisnik login(String korisnickoIme, String korisnickaSifra) throws Exception {
        try {
            Context ctx = new InitialContext();
            UserTransaction utx = (UserTransaction) ctx.lookup("java:comp/env/UserTransaction");
            //utx.begin();
            EntityManager em = (EntityManager) ctx.lookup("java:comp/env/persistence/LogicalName");
            List<Korisnik> korisnici = em.createNamedQuery("Korisnik.findByKorisnickoime").setParameter("korisnickoime", korisnickoIme).getResultList();
            if (korisnici.isEmpty()) {
                throw new Exception("Korisnik ne postoji");
            }

            Korisnik k = korisnici.get(0);
            if (k.getKorisnickasifra().equals(korisnickaSifra)) {
                return k;
            } else {
                throw new Exception("Sifra nije dobra");
            }
            //em.persist(object);
            //utx.commit();
        } catch (Exception e) {
            throw e;
        }
    }

}
